<?php
/**
 * Custom Functions.
 *
 * @package Local Supermarket
 */

if( !function_exists( 'local_supermarket_fonts_url' ) ) :

    //Google Fonts URL
    function local_supermarket_fonts_url(){

        $local_supermarket_font_families = array(
            'Montserrat:ital,wght@0,100..900;1,100..900', //   font-family: "Montserrat", sans-serif;
        );

        $local_supermarket_fonts_url = add_query_arg( array(
            'family' => implode( '&family=', $local_supermarket_font_families ),
            'display' => 'swap',
        ), 'https://fonts.googleapis.com/css2' );

        return esc_url_raw($local_supermarket_fonts_url);
    }

endif;

if ( ! function_exists( 'local_supermarket_sub_menu_toggle_button' ) ) :

    function local_supermarket_sub_menu_toggle_button( $local_supermarket_args, $local_supermarket_item, $depth ) {

        // Add sub menu toggles to the main menu with toggles
        if ( $local_supermarket_args->theme_location == 'local-supermarket-primary-menu' && isset( $local_supermarket_args->show_toggles ) ) {
            
            // Wrap the menu item link contents in a div, used for positioning
            $local_supermarket_args->before = '<div class="submenu-wrapper">';
            $local_supermarket_args->after  = '';

            // Add a toggle to items with children
            if ( in_array( 'menu-item-has-children', $local_supermarket_item->classes ) ) {

                $toggle_target_string = '.menu-item.menu-item-' . $local_supermarket_item->ID . ' > .sub-menu';

                // Add the sub menu toggle
                $local_supermarket_args->after .= '<button type="button" class="theme-aria-button submenu-toggle" data-toggle-target="' . $toggle_target_string . '" data-toggle-type="slidetoggle" data-toggle-duration="250" aria-expanded="false"><span class="btn__content" tabindex="-1"><span class="screen-reader-text">' . esc_html__( 'Show sub menu', 'local-supermarket' ) . '</span>' . local_supermarket_get_theme_svg( 'chevron-down' ) . '</span></button>';

            }

            // Close the wrapper
            $local_supermarket_args->after .= '</div><!-- .submenu-wrapper -->';
            // Add sub menu icons to the main menu without toggles (the fallback menu)

        }elseif( $local_supermarket_args->theme_location == 'local-supermarket-primary-menu' ) {

            if ( in_array( 'menu-item-has-children', $local_supermarket_item->classes ) ) {

                $local_supermarket_args->before = '<div class="link-icon-wrapper">';
                $local_supermarket_args->after  = local_supermarket_get_theme_svg( 'chevron-down' ) . '</div>';

            } else {

                $local_supermarket_args->before = '';
                $local_supermarket_args->after  = '';

            }

        }

        return $local_supermarket_args;

    }

endif;

add_filter( 'nav_menu_item_args', 'local_supermarket_sub_menu_toggle_button', 10, 3 );

if ( ! function_exists( 'local_supermarket_the_theme_svg' ) ):
    
    function local_supermarket_the_theme_svg( $local_supermarket_svg_name, $local_supermarket_return = false ) {

        if( $local_supermarket_return ){

            return local_supermarket_get_theme_svg( $local_supermarket_svg_name ); //phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped -- Escaped in local_supermarket_get_theme_svg();.

        }else{

            echo local_supermarket_get_theme_svg( $local_supermarket_svg_name ); //phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped -- Escaped in local_supermarket_get_theme_svg();.

        }
    }

endif;

if ( ! function_exists( 'local_supermarket_get_theme_svg' ) ):

    function local_supermarket_get_theme_svg( $local_supermarket_svg_name ) {

        // Make sure that only our allowed tags and attributes are included.
        $local_supermarket_svg = wp_kses(
            local_supermarket_SVG_Icons::get_svg( $local_supermarket_svg_name ),
            array(
                'svg'     => array(
                    'class'       => true,
                    'xmlns'       => true,
                    'width'       => true,
                    'height'      => true,
                    'viewbox'     => true,
                    'aria-hidden' => true,
                    'role'        => true,
                    'focusable'   => true,
                ),
                'path'    => array(
                    'fill'      => true,
                    'fill-rule' => true,
                    'd'         => true,
                    'transform' => true,
                ),
                'polygon' => array(
                    'fill'      => true,
                    'fill-rule' => true,
                    'points'    => true,
                    'transform' => true,
                    'focusable' => true,
                ),
                'polyline' => array(
                    'fill'      => true,
                    'points'    => true,
                ),
                'line' => array(
                    'fill'      => true,
                    'x1'      => true,
                    'x2' => true,
                    'y1'    => true,
                    'y2' => true,
                ),
            )
        );
        if ( ! $local_supermarket_svg ) {
            return false;
        }
        return $local_supermarket_svg;

    }

endif;

if( !function_exists( 'local_supermarket_post_category_list' ) ) :

    // Post Category List.
    function local_supermarket_post_category_list( $local_supermarket_select_cat = true ){

        $local_supermarket_post_cat_lists = get_categories(
            array(
                'hide_empty' => '0',
                'exclude' => '1',
            )
        );

        $local_supermarket_post_cat_cat_array = array();
        if( $local_supermarket_select_cat ){

            $local_supermarket_post_cat_cat_array[''] = esc_html__( '-- Select Category --','local-supermarket' );

        }

        foreach ( $local_supermarket_post_cat_lists as $local_supermarket_post_cat_list ) {

            $local_supermarket_post_cat_cat_array[$local_supermarket_post_cat_list->slug] = $local_supermarket_post_cat_list->name;

        }

        return $local_supermarket_post_cat_cat_array;
    }

endif;

if( !function_exists('local_supermarket_single_post_navigation') ):

    function local_supermarket_single_post_navigation(){

        $local_supermarket_default = local_supermarket_get_default_theme_options();
        $local_supermarket_twp_navigation_type = esc_attr( get_post_meta( get_the_ID(), 'twp_disable_ajax_load_next_post', true ) );
        $local_supermarket_current_id = '';
        $article_wrap_class = '';
        global $post;
        $local_supermarket_current_id = $post->ID;
        if( $local_supermarket_twp_navigation_type == '' || $local_supermarket_twp_navigation_type == 'global-layout' ){
            $local_supermarket_twp_navigation_type = get_theme_mod('twp_navigation_type', $local_supermarket_default['twp_navigation_type']);
        }

        if( $local_supermarket_twp_navigation_type != 'no-navigation' && 'post' === get_post_type() ){

            if( $local_supermarket_twp_navigation_type == 'theme-normal-navigation' ){ ?>

                <div class="navigation-wrapper">
                    <?php
                    // Previous/next post navigation.
                    the_post_navigation(array(
                        'prev_text' => '<span class="arrow" aria-hidden="true">' . local_supermarket_the_theme_svg('arrow-left',$local_supermarket_return = true ) . '</span><span class="screen-reader-text">' . esc_html__('Previous post:', 'local-supermarket') . '</span><span class="post-title">%title</span>',
                        'next_text' => '<span class="arrow" aria-hidden="true">' . local_supermarket_the_theme_svg('arrow-right',$local_supermarket_return = true ) . '</span><span class="screen-reader-text">' . esc_html__('Next post:', 'local-supermarket') . '</span><span class="post-title">%title</span>',
                    )); ?>
                </div>
                <?php

            }else{

                $local_supermarket_next_post = get_next_post();
                if( isset( $local_supermarket_next_post->ID ) ){

                    $local_supermarket_next_post_id = $local_supermarket_next_post->ID;
                    echo '<div loop-count="1" next-post="' . absint( $local_supermarket_next_post_id ) . '" class="twp-single-infinity"></div>';

                }
            }

        }

    }

endif;

add_action( 'local_supermarket_navigation_action','local_supermarket_single_post_navigation',30 );

if( !function_exists('local_supermarket_content_offcanvas') ):

    // Offcanvas Contents
    function local_supermarket_content_offcanvas(){ ?>

        <div id="offcanvas-menu">
            <div class="offcanvas-wraper">
                <div class="close-offcanvas-menu">
                    <div class="offcanvas-close">
                        <a href="javascript:void(0)" class="skip-link-menu-start"></a>
                        <button type="button" class="button-offcanvas-close">
                            <span class="offcanvas-close-label">
                                <?php echo esc_html__('Close', 'local-supermarket'); ?>
                            </span>
                        </button>
                    </div>
                </div>
                <div id="primary-nav-offcanvas" class="offcanvas-item offcanvas-main-navigation">
                    <nav class="primary-menu-wrapper" aria-label="<?php esc_attr_e('Horizontal', 'local-supermarket'); ?>" role="navigation">
                        <ul class="primary-menu theme-menu">
                            <?php
                            if (has_nav_menu('local-supermarket-primary-menu')) {
                                wp_nav_menu(
                                    array(
                                        'container' => '',
                                        'items_wrap' => '%3$s',
                                        'theme_location' => 'local-supermarket-primary-menu',
                                        'show_toggles' => true,
                                    )
                                );
                            }else{

                                wp_list_pages(
                                    array(
                                        'match_menu_classes' => true,
                                        'show_sub_menu_icons' => true,
                                        'title_li' => false,
                                        'show_toggles' => true,
                                        'walker' => new Local_Supermarket_Walker_Page(),
                                    )
                                );
                            }
                            ?>
                        </ul>
                    </nav><!-- .primary-menu-wrapper -->
                </div>
                <a href="javascript:void(0)" class="skip-link-menu-end"></a>
            </div>
        </div>

    <?php
    }

endif;

add_action( 'local_supermarket_before_footer_content_action','local_supermarket_content_offcanvas',30 );

if( !function_exists('local_supermarket_footer_content_widget') ):

    function local_supermarket_footer_content_widget(){
        
        $local_supermarket_default = local_supermarket_get_default_theme_options();
        
        $local_supermarket_footer_column_layout = absint(get_theme_mod('local_supermarket_footer_column_layout', $local_supermarket_default['local_supermarket_footer_column_layout']));
        $local_supermarket_footer_sidebar_class = 12;
        
        if($local_supermarket_footer_column_layout == 2) {
            $local_supermarket_footer_sidebar_class = 6;
        }
        
        if($local_supermarket_footer_column_layout == 3) {
            $local_supermarket_footer_sidebar_class = 4;
        }
        ?>
        
        <?php if ( get_theme_mod('local_supermarket_display_footer', true) == true ) : ?>
            <div class="footer-widgetarea">
                <div class="wrapper">
                    <div class="column-row">
                    
                        <?php for ($i = 0; $i < $local_supermarket_footer_column_layout; $i++) : ?>
                            
                            <div class="column <?php echo 'column-' . absint($local_supermarket_footer_sidebar_class); ?> column-sm-12">
                                
                                <?php 
                                // If no widgets are assigned, display default widgets
                                if ( ! is_active_sidebar( 'local-supermarket-footer-widget-' . $i ) ) : 

                                    if ($i === 0) : ?>
                                        <div id="media_image-3" class="widget widget_media_image">
                                            <img src="<?php echo esc_url(get_template_directory_uri() . '/assets/images/logo.png'); ?>" alt="<?php echo esc_attr__( 'Footer Image', 'local-supermarket' ); ?>" style="max-width: 100%; height: auto;">
                                        </div>
                                        <div id="text-3" class="widget widget_text">
                                            <div class="textwidget">
                                                <p class="widget_text">
                                                    <?php esc_html_e('The Local Supermarket Theme is designed for users who want a focused, visually appealing, and conversion-driven website without unnecessary complexity. Ideal for startups, product launches, digital services, and promotional campaigns, this theme helps you present your message clearly while keeping visitors engaged from the first scroll.', 'local-supermarket'); ?>
                                                </p>
                                            </div>
                                        </div>

                                    <?php elseif ($i === 1) : ?>
                                        <div id="pages-2" class="widget widget_pages">
                                            <h2 class="widget-title"><?php esc_html_e('Calendar', 'local-supermarket'); ?></h2>
                                            <?php get_calendar(); ?>
                                        </div>

                                    <?php elseif ($i === 2) : ?>
                                        <div id="search-2" class="widget widget_search">
                                            <h2 class="widget-title"><?php esc_html_e('Enter Keywords Here', 'local-supermarket'); ?></h2>
                                            <?php get_search_form(); ?>
                                        </div>
                                    <?php endif; 
                                    
                                else :
                                    // Display dynamic sidebar widget if assigned
                                    dynamic_sidebar('local-supermarket-footer-widget-' . $i);
                                endif;
                                ?>
                                
                            </div>
                            
                        <?php endfor; ?>

                    </div>
                </div>
            </div>
        <?php endif; ?> 

    <?php
    }

endif;

add_action( 'local_supermarket_footer_content_action', 'local_supermarket_footer_content_widget', 10 );

if( !function_exists('local_supermarket_footer_content_info') ):

    /**
     * Footer Copyright Area
    **/
    function local_supermarket_footer_content_info(){

        $local_supermarket_default = local_supermarket_get_default_theme_options(); ?>
        <div class="site-info">
            <div class="wrapper">
                <div class="column-row">

                    <div class="column column-9">
                        <div class="footer-credits">

                            <div class="footer-copyright">

                                <?php
                                $local_supermarket_footer_copyright_text = wp_kses_post( get_theme_mod( 'local_supermarket_footer_copyright_text', $local_supermarket_default['local_supermarket_footer_copyright_text'] ) );
                                    echo esc_html( $local_supermarket_footer_copyright_text );
                                    echo '<br>';

                                    echo esc_html__('Theme: ', 'local-supermarket') . '<a href="' . esc_url('https://www.omegathemes.com/products/local-supermarket') . '" title="' . esc_attr__('Local Supermarket  ', 'local-supermarket') . '" target="_blank"><span>' . esc_html__('Local Supermarket  ', 'local-supermarket') . '</span></a>' . esc_html__(' By ', 'local-supermarket') . '  <span>' . esc_html__('OMEGA ', 'local-supermarket') . '</span>';
                                    echo esc_html__('Powered by ', 'local-supermarket') . '<a href="' . esc_url('https://wordpress.org') . '" title="' . esc_attr__('WordPress', 'local-supermarket') . '" target="_blank"><span>' . esc_html__('WordPress.', 'local-supermarket') . '</span></a>';
                                 ?>

                            </div>
                        </div>
                    </div>


                    <div class="column column-3 align-text-right">
                        <a class="to-the-top" href="#site-header">
                            <span class="to-the-top-long">
                                <?php if ( get_theme_mod('local_supermarket_enable_to_the_top', true) == true ) : ?>
                                    <?php
                                    $local_supermarket_to_the_top_text = get_theme_mod( 'local_supermarket_to_the_top_text', __( 'To the Top', 'local-supermarket' ) );
                                    printf( 
                                        wp_kses( 
                                            /* translators: %s is the arrow icon markup */
                                            '%s %s', 
                                            array( 'span' => array( 'class' => array(), 'aria-hidden' => array() ) ) 
                                        ), 
                                        esc_html( $local_supermarket_to_the_top_text ),
                                        '<span class="arrow" aria-hidden="true">&uarr;</span>' 
                                    );
                                    ?>
                                <?php endif; ?>
                            </span>
                        </a>

                    </div>
                </div>
            </div>
        </div>

    <?php
    }

endif;

add_action( 'local_supermarket_footer_content_action','local_supermarket_footer_content_info',20 );

if (!function_exists('local_supermarket_post_format_icon')):

    // Post Format Icon.
    function local_supermarket_post_format_icon() {

        $local_supermarket_format = get_post_format(get_the_ID()) ?: 'standard';
        $local_supermarket_icon = '';
        $local_supermarket_title = '';
        if( $local_supermarket_format == 'video' ){
            $local_supermarket_icon = local_supermarket_get_theme_svg( 'video' );
            $local_supermarket_title = esc_html__('Video','local-supermarket');
        }elseif( $local_supermarket_format == 'audio' ){
            $local_supermarket_icon = local_supermarket_get_theme_svg( 'audio' );
            $local_supermarket_title = esc_html__('Audio','local-supermarket');
        }elseif( $local_supermarket_format == 'gallery' ){
            $local_supermarket_icon = local_supermarket_get_theme_svg( 'gallery' );
            $local_supermarket_title = esc_html__('Gallery','local-supermarket');
        }elseif( $local_supermarket_format == 'quote' ){
            $local_supermarket_icon = local_supermarket_get_theme_svg( 'quote' );
            $local_supermarket_title = esc_html__('Quote','local-supermarket');
        }elseif( $local_supermarket_format == 'image' ){
            $local_supermarket_icon = local_supermarket_get_theme_svg( 'image' );
            $local_supermarket_title = esc_html__('Image','local-supermarket');
        } elseif( $local_supermarket_format == 'link' ){
            $local_supermarket_icon = local_supermarket_get_theme_svg( 'link' );
            $local_supermarket_title = esc_html__('Link','local-supermarket');
        } elseif( $local_supermarket_format == 'status' ){
            $local_supermarket_icon = local_supermarket_get_theme_svg( 'status' );
            $local_supermarket_title = esc_html__('Status','local-supermarket');
        } elseif( $local_supermarket_format == 'aside' ){
            $local_supermarket_icon = local_supermarket_get_theme_svg( 'aside' );
            $local_supermarket_title = esc_html__('Aside','local-supermarket');
        } elseif( $local_supermarket_format == 'chat' ){
            $local_supermarket_icon = local_supermarket_get_theme_svg( 'chat' );
            $local_supermarket_title = esc_html__('Chat','local-supermarket');
        }
        
        if (!empty($local_supermarket_icon)) { ?>
            <div class="theme-post-format">
                <span class="post-format-icom"><?php echo local_supermarket_svg_escape($local_supermarket_icon); ?></span>
                <?php if( $local_supermarket_title ){ echo '<span class="post-format-label">'.esc_html( $local_supermarket_title ).'</span>'; } ?>
            </div>
        <?php }
    }

endif;

if ( ! function_exists( 'local_supermarket_svg_escape' ) ):

    /**
     * Get information about the SVG icon.
     *
     * @param string $local_supermarket_svg_name The name of the icon.
     * @param string $group The group the icon belongs to.
     * @param string $color Color code.
     */
    function local_supermarket_svg_escape( $local_supermarket_input ) {

        // Make sure that only our allowed tags and attributes are included.
        $local_supermarket_svg = wp_kses(
            $local_supermarket_input,
            array(
                'svg'     => array(
                    'class'       => true,
                    'xmlns'       => true,
                    'width'       => true,
                    'height'      => true,
                    'viewbox'     => true,
                    'aria-hidden' => true,
                    'role'        => true,
                    'focusable'   => true,
                ),
                'path'    => array(
                    'fill'      => true,
                    'fill-rule' => true,
                    'd'         => true,
                    'transform' => true,
                ),
                'polygon' => array(
                    'fill'      => true,
                    'fill-rule' => true,
                    'points'    => true,
                    'transform' => true,
                    'focusable' => true,
                ),
            )
        );

        if ( ! $local_supermarket_svg ) {
            return false;
        }

        return $local_supermarket_svg;

    }

endif;

if( !function_exists( 'local_supermarket_sanitize_sidebar_option_meta' ) ) :

    // Sidebar Option Sanitize.
    function local_supermarket_sanitize_sidebar_option_meta( $local_supermarket_input ){

        $local_supermarket_metabox_options = array( 'global-sidebar','left-sidebar','right-sidebar','no-sidebar' );
        if( in_array( $local_supermarket_input,$local_supermarket_metabox_options ) ){

            return $local_supermarket_input;

        }else{

            return '';

        }
    }

endif;

if( !function_exists( 'local_supermarket_sanitize_pagination_meta' ) ) :

    // Sidebar Option Sanitize.
    function local_supermarket_sanitize_pagination_meta( $local_supermarket_input ){

        $local_supermarket_metabox_options = array( 'Center','Right','Left');
        if( in_array( $local_supermarket_input,$local_supermarket_metabox_options ) ){

            return $local_supermarket_input;

        }else{

            return '';

        }
    }

endif;

if( !function_exists( 'local_supermarket_sanitize_menu_transform' ) ) :

    // Sidebar Option Sanitize.
    function local_supermarket_sanitize_menu_transform( $local_supermarket_input ){

        $local_supermarket_metabox_options = array( 'capitalize','uppercase','lowercase');
        if( in_array( $local_supermarket_input,$local_supermarket_metabox_options ) ){

            return $local_supermarket_input;

        }else{

            return '';

        }
    }

endif;

if( !function_exists( 'local_supermarket_sanitize_page_content_alignment' ) ) :

    // Sidebar Option Sanitize.
    function local_supermarket_sanitize_page_content_alignment( $local_supermarket_input ){

        $local_supermarket_metabox_options = array( 'left','center','right');
        if( in_array( $local_supermarket_input,$local_supermarket_metabox_options ) ){

            return $local_supermarket_input;

        }else{

            return '';

        }
    }

endif;

if( !function_exists( 'local_supermarket_sanitize_footer_widget_title_alignment' ) ) :

    // Footer Option Sanitize.
    function local_supermarket_sanitize_footer_widget_title_alignment( $local_supermarket_input ){

        $local_supermarket_metabox_options = array( 'left','center','right');
        if( in_array( $local_supermarket_input,$local_supermarket_metabox_options ) ){

            return $local_supermarket_input;

        }else{

            return '';

        }
    }

endif;

if( !function_exists( 'local_supermarket_sanitize_pagination_type' ) ) :

    /**
     * Sanitize the pagination type setting.
     *
     * @param string $local_supermarket_input The input value from the Customizer.
     * @return string The sanitized value.
     */
    function local_supermarket_sanitize_pagination_type( $local_supermarket_input ) {
        // Define valid options for the pagination type.
        $local_supermarket_valid_options = array( 'numeric', 'newer_older' ); // Update valid options to include 'newer_older'

        // If the input is one of the valid options, return it. Otherwise, return the default option ('numeric').
        if ( in_array( $local_supermarket_input, $local_supermarket_valid_options, true ) ) {
            return $local_supermarket_input;
        } else {
            // Return 'numeric' as the fallback if the input is invalid.
            return 'numeric';
        }
    }

endif;


// Sanitize the enable/disable setting for pagination
if( !function_exists('local_supermarket_sanitize_enable_pagination') ) :
    function local_supermarket_sanitize_enable_pagination( $local_supermarket_input ) {
        return (bool) $local_supermarket_input;
    }
endif;

if( !function_exists( 'local_supermarket_sanitize_copyright_alignment_meta' ) ) :

    // Sidebar Option Sanitize.
    function local_supermarket_sanitize_copyright_alignment_meta( $local_supermarket_input ){

        $local_supermarket_metabox_options = array( 'Default','Reverse','Center');
        if( in_array( $local_supermarket_input,$local_supermarket_metabox_options ) ){

            return $local_supermarket_input;

        }else{

            return '';

        }
    }

endif;

/**
 * Sidebar Layout Function
 */
function local_supermarket_get_final_sidebar_layout() {
	$local_supermarket_defaults       = local_supermarket_get_default_theme_options();
	$local_supermarket_global_layout  = get_theme_mod('local_supermarket_global_sidebar_layout', $local_supermarket_defaults['local_supermarket_global_sidebar_layout']);
	$local_supermarket_page_layout    = get_theme_mod('local_supermarket_page_sidebar_layout', $local_supermarket_global_layout);
	$local_supermarket_post_layout    = get_theme_mod('local_supermarket_post_sidebar_layout', $local_supermarket_global_layout);
	$local_supermarket_meta_layout    = get_post_meta(get_the_ID(), 'local_supermarket_post_sidebar_option', true);

	if (!empty($local_supermarket_meta_layout) && $local_supermarket_meta_layout !== 'default') {
		return $local_supermarket_meta_layout;
	}
	if (is_page() || (function_exists('is_shop') && is_shop())) {
		return $local_supermarket_page_layout;
	}
	if (is_single()) {
		return $local_supermarket_post_layout;
	}
	return $local_supermarket_global_layout;
}